bool P_in_CS = false;
bool Q_in_CS = false;
byte critical = 0;

active proctype P() {
  do
    :: printf("Non-critical section P\n");
       atomic {
         !Q_in_CS;
         P_in_CS = true
       }
       /* begin critical section */
       critical++;
       printf("Critical section P\n");
       assert (critical <= 1);
       critical--;
       /* end critical section */
       P_in_CS = false
 od
}

active proctype Q() {        
  do 
    :: printf("Non-critical section Q\n");
       atomic {
         !P_in_CS;
         Q_in_CS = true
       }
       /* begin critical section */
       critical++;
       assert (critical <= 1);
       critical--;
       printf("Critical section Q\n");
       /* end critical section */
       Q_in_CS = false
  od
}
